/* -*- C++ -*-
 *******************************************************************
 *
 *
 * BmpUtil.h - Declaration of the CBmpUtil class
 *
 *
 *******************************************************************
 *
 * Bitmap utilities class
 *
 *******************************************************************
 *
 * Created 2000-12-28 by Jim Mason <jmason@sirius.com>
 *
 * LoadBmpImage function created 1998-08-05 by Zafir Anjum; see
 *      http://codeguru.earthweb.com/bitmap/bitmap_from_bmp.shtml
 *
 *******************************************************************
 *
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 *******************************************************************
 */


#ifndef _BMPUTIL_H_
#define _BMPUTIL_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBmpUtil {
public:
    static BOOL LoadBmpImage(LPCSTR szBmpFile, HBITMAP* phBitmap=NULL,
                                HPALETTE *phPal=NULL);
    static void FastDrawBitmap(HDC hDC, int xpos, int ypos,
                                int nWidth, int nHeight,
                                HDC hSrcDC, int xOrigin, int yOrigin,
                                HDC hMaskDC, int xMask=0, int yMask=0);
    static void DrawBitmap(HDC hDC, HBITMAP hBitmap, int xpos, int ypos,
                                int width, int height,
                                int xOrigin=0, int yOrigin=0);
};


#endif // ndef _BMPUTIL_H_
