/* -*- C++ -*-
 *******************************************************************
 *
 *
 * registry.h - Declaration of the Registry class
 *
 *
 *******************************************************************
 *
 * Registry access class
 *
 *******************************************************************
 *
 * Created 2000-12-28 by Jim Mason <jmason@sirius.com>
 *
 * Copyright (C) 2001 Jim Mason.
 *
 *******************************************************************
 *
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this file; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *******************************************************************
 */


#ifndef _REGISTRY_H_
#define _REGISTRY_H_

#include "StdString.h"

class Registry {
public:
    Registry();

public:
    void SetRegistryKey(LPCTSTR szAppName, LPCTSTR szRegistryKey);
    UINT GetProfileInt(LPCTSTR szSection, LPCTSTR szEntry, int nDefault);
    CStdString GetProfileString(LPCTSTR szSection, LPCTSTR szEntry,
                                        LPCTSTR szDefault);
    BOOL WriteProfileInt(LPCTSTR szSection, LPCTSTR szEntry, int nValue);
    BOOL WriteProfileString(LPCTSTR szSection, LPCTSTR szEntry,
                                        LPCTSTR szValue);

protected:
    HKEY GetAppRegistryKey();
    HKEY GetSectionKey(LPCTSTR szSection);

protected:
    CStdString m_szRegistryKey;
    CStdString m_szProfileName;
};

#endif // ndef _REGISTRY_H_
