/* -*- C++ -*-
 *******************************************************************
 *
 *
 * Shisen-Sho for Windows
 *
 * shisen.h - Global function headers
 *
 *
 *******************************************************************
 *
 * A japanese game similar to mahjongg
 *
 *******************************************************************
 *
 * Created 2000-12-28 by Jim Mason <jmason@sirius.com>
 *
 * Game engine ported from Mario Weilguni's <mweilguni@sime.com>
 * original game for KDE, KSHISEN.  If you are interested in the
 * KDE version of the game, see http://www.kde.org/kdegames/
 *
 *******************************************************************
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 *******************************************************************
 */

#ifndef _SHISEN_H_
#define _SHISEN_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "frame.h"
#include "registry.h"

class App {
public:
    // Implementation
    static BOOL InitInstance(HINSTANCE, int);

public:
    // Accessors
    static HINSTANCE    GetHInstance()  { return m_hInst; }
    static HWND         GetMainHWnd()   { return m_frame.GetHWnd(); }
    static LPCTSTR      GetAppName()    { return m_szTitle; }
    static Registry*    GetProfile()    { return &m_profile; }

protected:
    static Frame        m_frame;    // main frame window
    static Registry     m_profile;  // registry access
    static HINSTANCE    m_hInst;    // current instance
    static CStdString   m_szTitle;  // application title
};

#endif // ndef _SHISEN_H_
